/*	
 *	fmem4.c
 *
 *	uToggle Bit(DQ6)v肭ȂƂmFTv
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Mon Jul 29 04:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33209.h"

/****************************************************************************
 *
 ****************************************************************************/

#define FMEM_ADDR ((unsigned short*)0xc00000) /* tbṼx[XAhX */
#define TEST_ADDR ((unsigned short*)0xc70000) /* eXgɎg̈̃x[XAhX */
                                              /* EZN^@ł0xc70000`0xc70fff( 4KB) */
                                              /* EubNł0xc70000`0xc7ffff(64KB) */
                                              /* g܂B */

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */

#define MAX_LOG		128	/* [h̃O邩? */
unsigned short log[MAX_LOG];	/* Oi[̈            */

void toggle_bit_test(volatile unsigned short* addr);

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceLCDDispStart();

	/* TEST_ADDR̈ʒũZN^R}h𔭍sA
	 * R}hs̓ǂݍݒl̃O܂B
	 */
	toggle_bit_test(TEST_ADDR);
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	int i, joy, x, y;

	/* pbhԂ擾܂B */
	joy = pcePadGet();

	/* SELECT{^ꂽI܂B */
	if(joy & TRG_SELECT) {
		pceAppReqExit(0);
		return;
	}

	/* ʏB */
	memset(vbuff, 0, sizeof vbuff);

	/* O\B */
	pceFontSetType(0x02);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	pceFontSetPos(0, 0);
	for(i = 0; i < MAX_LOG; i++) {
		pceFontPrintf(" %04x", log[i]);
	}

	/* ʓ]B */
	pceLCDTrans();
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
}

/****************************************************************************
 *	toggle_bit_test
 ****************************************************************************/

void
toggle_bit_test(volatile unsigned short* addr)
{
	volatile unsigned short* c1p = FMEM_ADDR + 0x5555;
	volatile unsigned short* c2p = FMEM_ADDR + 0x2aaa;
	unsigned char saveNMI;
	int i;

DISABLE;
	/* EHb`hbO^C}~B */
	saveNMI = bWD_EN_EWD;
	bWD_WP_WRWD = 1;
	bWD_EN_EWD = 0;

	/* ZN^[hɓ܂B */
	*c1p = 0xaa;
	*c2p = 0x55;
	*c1p = 0x80;
	*c1p = 0xaa;
	*c2p = 0x55;

	/* ZN^̔Cӂ̃AhXɁA0x30݂܂B
	 * ZN^̐擪AhXłȂĂ\܂B
	 * ޒlԈႦƁAubN`bv(!!)ɂȂĂ܂\܂B
	 * ޒĺw0x30xłI΂ɊԈႦȂ悤ɁI
	 */
	*addr = 0x30;

	/* ZN^R}hsɁAǂȒlǂݏoĂ̂AO܂B */
	for(i = 0; i < MAX_LOG; i++) {
		log[i] = *addr;
		/* ZN^͒x̂ŁAtXs[hŃOƁA
		 * ܂łɐ\L[h̃Ö悪KvɂȂĂ܂܂B
		 * EFCgāAƃOԊu𒷂߂ɂ܂B
		 */
		{ volatile int j; for(j = 0; j < 100; j++) { } }
	}

	/* OIĂZN^ĂȂ\̂ŁAmɑ҂܂B */
	while(*addr != 0xffff) { /*󃋁[v*/ }

	/* EHb`hbO^C}B */
	bWD_WP_WRWD = 1;
	bWD_EN_EWD = saveNMI;
ENABLE;
}
